unit usortdemo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,

// pour UTF8CompareStr dans DoCompareCells
// nécéssaire pour trier correctement les données contenant des espaces.
  LazUTF8,

// pour spreadsheet
  fpsTypes,
  fpsutils,
  fpspreadsheet, fpspreadsheetctrls, fpspreadsheetgrid;

type
  TFsortdemo = class(TForm)
    BtnLoad: TButton;
    BtnSort: TButton;
    wb: TsWorkbookSource;
    ws: TsWorksheetGrid;
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnSortClick(Sender: TObject);
		
// nécéssaire pour trier correctement les données contenant des espaces.
    procedure DoCompareCells(Sender: TObject; ACell1, ACell2: PCell; ASortKey: TsSortKey; var AResult: Integer);
    procedure FormCreate(Sender: TObject);

  private

  public

  end;

var
  Fsortdemo: TFsortdemo;

implementation

{$R *.lfm}

var
  sortParams: TsSortParams;
	
// nécéssaire pour trier correctement les données contenant des espaces.
procedure TFsortdemo.DoCompareCells(Sender: TObject; ACell1, ACell2: PCell; ASortKey: TsSortKey; var AResult: Integer);
var
  A, B: string;
begin
  A := TsWorksheet(Sender).ReadAsText(ACell1^.row, ACell1^.col);
  B := TsWorksheet(Sender).ReadAsText(ACell2^.row, ACell2^.col);
  AResult := UTF8CompareStr(A, B);
  if (ssoDescending in ASortKey.options) then AResult := -AResult;
end;

procedure TFsortdemo.BtnLoadClick(Sender: TObject);
begin
  // initialisation et chargement manuel du Worksheet
  with wb.Worksheet do begin
    Clear;
    WriteText(0, 0, 'ACinq');
    WriteText(1, 0, 'A Huit');
    WriteText(2, 0, 'ANeuf');
  end;
end;

procedure TFsortdemo.BtnSortClick(Sender: TObject);
begin
  sortParams := InitSortParams(true, 1);    // Col sort, Number of sort (cols or rows)
  sortParams.Keys[0].ColRowIndex := 0;      // ColRowIndex    Index of the sorted column or row
  sortParams.Keys[0].Options := [];         // TsSortOption = (ssoDescending, ssoCaseInsensitive, ssoAlphaBeforeNum)
  with wb.Worksheet do begin
    Sort(sortParams, 0, 0, GetLastRowIndex, GetLastColIndex);
  end;
end;

procedure TFsortdemo.FormCreate(Sender: TObject);
begin
// nécéssaire pour trier correctement les données contenant des espaces.
  wb.Worksheet.OnFullCompareCells := @DoCompareCells;
end;

end.

